package io.reisub.dreambot.cshopper;

public class ItemWrapper {
    private final String name;
    private final int buyTotal, minimumInShop;
    private final boolean stackable;

    public ItemWrapper(String name, int buyTotal, int minimumInShop, boolean stackable) {
        this.name = name;
        this.buyTotal = buyTotal;
        this.minimumInShop = minimumInShop;
        this.stackable = stackable;
    }

    public ItemWrapper(String name, int buyTotal, boolean stackable) {
        this(name, buyTotal, 0, stackable);
    }

    public ItemWrapper(String name, int buyTotal, int minimumInShop) {
        this(name, buyTotal, minimumInShop, false);
    }

    public ItemWrapper(String name, int buyTotal) {
        this(name, buyTotal, 0, false);
    }

    public String getName() {
        return name;
    }

    public int getBuyTotal() {
        return buyTotal;
    }

    public int getMinimumInShop() {
        return minimumInShop;
    }

    public boolean isStackable() {
        return stackable;
    }
}
