package io.reisub.dreambot.csmelter;

import io.reisub.dreambot.csmelter.tasks.DoBank;
import io.reisub.dreambot.csmelter.tasks.OpenBank;
import io.reisub.dreambot.csmelter.tasks.SetCamera;
import io.reisub.dreambot.csmelter.tasks.Smelt;
import io.reisub.dreambot.util.CTaskScript;
import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.randomevents.GenieSolver;
import io.reisub.dreambot.util.tasks.Run;
import io.reisub.dreambot.util.tasks.kitten.KittenTask;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.script.Category;
import org.dreambot.api.script.ScriptManifest;
import org.dreambot.api.script.TaskNode;

@ScriptManifest(category = Category.SMITHING, name = "CSmelter", author = Constants.AUTHOR, version = 1.0)
public class CSmelter extends CTaskScript {
    public static SmeltingOption smeltingOption = SmeltingOption.GOLD_BRACELET;

    @Override
    public void onStart() {
        super.onStart();
        getRandomManager().registerSolver(new GenieSolver(GenieSolver.Skill.HERBLORE));

        if (smeltingOption.getMould().equals("")) {
            getUI().addSkills(Skill.SMITHING);
        } else {
            getUI().addSkills(Skill.CRAFTING);
        }

        TaskNode kittenTask = KittenTask.getInstance();
        if (kittenTask != null) {
            addNodes(kittenTask);
        }

        addNodes(
                new SetCamera(),
                new Run(),
                new Smelt(),
                new OpenBank(),
                new DoBank()
        );
    }
}
