package io.reisub.dreambot.util;

import io.reisub.dreambot.util.ui.UI;
import org.dreambot.api.Client;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.script.impl.TaskScript;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public abstract class CTaskScript extends TaskScript implements MouseListener {
    private final UI ui;

    public CTaskScript() {
        ui = UI.getInstance(getSDNName() + " v" + getVersion());
        MethodContext.log("Util version " + Util.getVersion());
    }

    public UI getUI() {
        return ui;
    }

    @Override
    public void onPaint(Graphics g){
        ui.draw(g);
    }

    @Override
    public void onStart() {
        MethodProvider.sleep(1000);
        Client.getInstance().setKeyboardInputEnabled(true);
    }

    @Override
    public void onPause() {
        ui.pause();
    }

    @Override
    public void onResume() {
        Client.getInstance().setKeyboardInputEnabled(true);
        ui.resume();
    }

    @Override
    public void mouseClicked(MouseEvent mouseEvent) {
        ui.mouseClicked(mouseEvent);
    }

    @Override
    public void mousePressed(MouseEvent mouseEvent) {
        ui.mousePressed(mouseEvent);
    }

    @Override
    public void mouseReleased(MouseEvent mouseEvent) {
        ui.mouseReleased(mouseEvent);
    }

    @Override
    public void mouseEntered(MouseEvent mouseEvent) {
        ui.mouseEntered(mouseEvent);
    }

    @Override
    public void mouseExited(MouseEvent mouseEvent) {
        ui.mouseExited(mouseEvent);
    }
}
